.module _cpc_DrawHorizontalLine
.globl _cpc_DrawHorizontalLine

;;---------------------------------------------------------------------------------------------------------------------------------
.area _CODE

;; x coordinate
;; y coordinate
;; width

_cpc_DrawHorizontalLine: 
	ld ix,#2
	add ix,sp
	
	ld c,(ix+4)
	ld b,(ix+5)
	
	ld e,(ix+0)		;; x coordinate
	ld d,(ix+1)
	srl d
	rr e			;; /2 for mode 0
	
	ld l,(ix+2)		;; y coordinate
	ld h,(ix+3)
	call _cpc_GetScrAddrInternal
	
	;; HL = screen coordinate

	;; BC = width
	
	;; X coordinate lower byte
	bit 0,(ix+0)
	;; 0 means all pixels used of this byte
	jr z,dvl2
	;; 1 less byte to write
	dec bc

	dvl4:
		
	ld a,(_cpc_EncodedPen)
	and &55
	ld d,a

dvl2:
ld a,d
or a
jr z,dvl3
	
	ld a,(hl)
	and &aa
	or d
	ld (hl),a

dvl3:
bit 0,c
jr z,dvl4

ld a,(_cpc_EncodedPen)
and &aa
ld e,a

dvl4:	
srl b
rr c

ld a,(_cpc_EncodedPen)
;; pixels in the middle
dvl1:
ld (hl),a
inc hl
djnz dvl1

ld a,e
or a
ret z

;; right pixel
ld a,(hl)
and &55
or e
ld (hl),a

ret



;;---------------------------------------------------------------------------------------------------------------------------------
