;; example
;; ld de,plus_palette
;; call init_fade_out

;;
;; ld de,plus_palette
;; call init_fade_in

;;
;; call update_fade
;; call update_fade_cols

;; de = plus palette
init_fade_out:
push de
ld hl,temp_fade
ld b,32
ifo:
ld a,(de) ;; r
and &f0  ;; 
ld (hl),a
inc hl
ld a,(de) ;; b
add a,a
add a,a
add a,a
add a,a
and &f0
ld (hl),a
inc de
inc hl
ld a,(de) ;; g
add a,a
add a,a
add a,a
add a,a
and &f0
ld (hl),a
inc de
inc hl
djnz ifo
pop de
call init_fade_add
ret

init_fade_add:
ld hl,fade_add
ld b,32
ifa:
ld a,(de) ;; r
rrca
rrca
rrca
rrca
and &f
ld (hl),a
inc hl
ld a,(de) ;; b
and &f
ld (hl),a
inc de
inc hl
ld a,(de) ;; g
and &f
ld (hl),a
inc de
inc hl
djnz ifa
ret

update_fade_in:
ld hl,fade_add
ld de,temp_fade
ld b,32*3
uf1:
ld a,(de)
add a,(hl)
ld (de),a
inc de
inc hl
djnz uf1
ret

update_fade_out:
ld hl,fade_add
ld de,temp_fade
ld b,32*3
ufo1:
ld a,(de)
sub (hl)
ld (de),a
inc de
inc hl
djnz ufo1
ret


;; de = palette
init_fade_in:
push de
ld hl,temp_fade
ld e,l
ld d,h
inc de
ld (hl),0
ld bc,end_temp_fade-temp_fade-1
ldir
pop de
call init_fade_add
ret

;; RB | G
update_fade_cols:
ld de,temp_fade
ld hl,&6400 ;; asic ram palette address
ld b,32     ;; 16 main colours + border + sprite colours
write_cols:
ld a,(de)   ;; R
inc de
and &f0
ld c,a

ld a,(de)   ;; B
inc de
rrca
rrca
rrca
rrca
and &f
or c
ld (hl),a
inc l

ld a,(de)   ;; G
inc de
rrca
rrca
rrca
rrca
and &f
ld (hl),a
inc l
djnz write_cols
ret

;; 4:4 fixed point
;; upper 4 bits are displayed, lower 4 bits are fraction
temp_fade:
defs 32*3
end_temp_fade:

;; add value to do fade out or in
fade_add:
defs 32*3
end_fade_add