set PATH=%PATH%;c:\tools
cd lib\mylib
call make.bat
cd ..\..
cd lib\arkostrackerlib
call make.bat
cd ..\..
cd music
AKSToBIN.exe -a 0x08100 game_over.aks game_over.aks.bin
dm -t 1 -l game_over_aks_bin game_over.aks.bin game_over_aks_bin.h 
cd ..

sdcc -c --verbose -V --nostdlib --opt-code-speed --nostdinc --no-std-crt0 -mz80 -DDISC=1 -I lib/mylib -l lib/mylib/mylib.lib -I lib/arkostrackerlib -l lib/arkostrackerlib/arkostrackerlib.lib mustest.c 
if %ERRORLEVEL% NEQ 0 goto :error
sdldz80 -f custom_mus.lk
hex2bin mustest.ihx


addhead -s 0x200 -x 0x200 mustest.bin mustest.bin

cpcxfs -f -nD mustest.dsk
cpcxfs mustest.dsk -f -b -p mustest.bin mustest

:error